#ifndef _Trait_h
#define _Trait_h

#include <type_traits>

// Inspiration from: https://stackoverflow.com/questions/17390605/doing-a-static-assert-that-a-template-type-is-another-template

template<typename T> class My_template {
	/* Given a template class... */
};

namespace V1 {

	template<typename Realized, template<typename> class Realizer> class is_realization_of : public std::integral_constant<bool, false > /* <=> std::false_type */ {
	};

	template<typename Realized, template<typename> class Realizer> class is_realization_of<Realizer<Realized>, Realizer> : public std::true_type {
	};

	// 'My_template_realization' is indeed 'My_template<T>' for some 'T':

	template<typename My_template_realization> class My_class {
		// Caution: comma is misinterpreted by the pre-processor, requiring extra parentheses:
		static_assert((is_realization_of<My_template_realization, My_template>::value), "failure");
	};
}

namespace V2 { // For any number of (template) effective types...

	template<template<typename...> class TT, typename T> class is_realizer_of : std::false_type {
	};

	template<template<typename...> class TT, typename... Ts> class is_realizer_of<TT, TT<Ts...> > : std::true_type {
	};

	template<typename My_template_realization> class My_class {
		static_assert((is_realizer_of<My_template, My_template_realization>::value), "failure");
	};
}

#endif
